#define N_OPERATORS     2
static const char operator_list[N_OPERATORS] = {'+', '*'};

typedef enum {none, cst, mem, reg1, reg2, reg_7r1, reg_7r2, reg_8r1, reg_8r2, max_location} Location;

#define N_BASIC_LOCATIONS   2
static Location basic_location_list[N_BASIC_LOCATIONS] = {cst, mem};

#define N_ACTUAL_LOCATIONS  4
static Location actual_location_list[N_ACTUAL_LOCATIONS] =
    {cst, mem, reg1, reg2};

static char *
location2string(Location op) {
    switch (op) {
    case none: return "none";
    case cst: return "cst";
    case mem: return "mem";
    case reg1: return "reg1";
    case reg2: return "reg2";
    case reg_7r1: return "reg_7r1";
    case reg_7r2: return "reg_7r2";
    case reg_8r1: return "reg_8r1";
    case reg_8r2: return "reg_8r2";
    case max_location: return "max_location";
    default: return "<<<< Bad Location value >>>>";
    }
}

typedef struct {
    char *name;
    char operator;
    Location operand, second_operand;
    Location result;
    int cost;
} Instr;

static const Instr instr_list[] = {
    {"#1r1", ' ', cst, none, reg1, 1},
    {"#1r2", ' ', cst, none, reg2, 1},
    {"#2r1", ' ', mem, none, reg1, 3},
    {"#2r2", ' ', mem, none, reg2, 3},

    {"#3r1", '+', reg1, mem, reg1, 3},
    {"#3r2", '+', reg2, mem, reg2, 3},
    {"#4r1r2", '+', reg1, reg2, reg1, 1},
    {"#4r2r1", '+', reg2, reg1, reg2, 1},
    {"#7r1", '+', reg1, reg_7r2, reg1, 4},
    {"#7r2", '+', reg2, reg_7r1, reg2, 4},

    {"#5r1", '*', reg1, mem, reg1, 6},
    {"#5r2", '*', reg2, mem, reg2, 6},
    {"#6r1r2", '*', reg1, reg2, reg1, 4},
    {"#6r2r1", '*', reg2, reg1, reg2, 4},
    {"#7.1r1", '*', cst, reg1, reg_7r1, 0},
    {"#7.1r2", '*', cst, reg2, reg_7r2, 0},
    {"#8r1", '*', reg1, reg_8r2, reg1, 5},
    {"#8r2", '*', reg2, reg_8r1, reg2, 5},
    {"#8.1r1", '*', cst, reg1, reg_8r1, 0},
    {"#8.1r2", '*', cst, reg2, reg_8r2, 0},

    {0, ' ', none, none, none, 0}
};
