int unify_terms(Term *goal_arg, Term *head_arg) {
    /* Handle any bound variables: */
    Term *goal = deref(goal_arg);
    Term *head = deref(head_arg);

    if (goal->type == Is_Variable || head->type == Is_Variable) {
        /* Handle identical variables: */
        if (goal == head) return 1;

        /* Bind the unbound variable to the other term: */
        if (head->type == Is_Variable) {
            trail_binding(head);
            head->term.variable.term = goal;
        }
        else {
            trail_binding(goal);
            goal->term.variable.term = head;
        }
        return 1;           /* always succeeds */
    }
    else {
        /* Handle terms of different type: */
        if (goal->type != head->type) return 0;

        switch (goal->type) {
        case Is_Constant:           /* both are constants */
            return strcmp(goal->term.constant, head->term.constant) == 0;
        case Is_Structure:          /* both are structures */
            return unify_structures(
                &goal->term.structure, &head->term.structure
            );
        }
    }
}

