int unify_constant(Term *goal_arg, char *head_text) {
    Term *goal;

    /* Handle bound goal_arg: */
    goal = deref(goal_arg);

    if (goal->type == Is_Variable
    ||  (put_constant(head_text))->type == Is_Variable
    ) {
        /* Handle identical variables: */
        if (goal == (put_constant(head_text))) return 1;

        /* Bind the unbound variable to the other term: */
        if ((put_constant(head_text))->type == Is_Variable) {
            trail_binding((put_constant(head_text)));
            (put_constant(head_text))->term.variable.term = goal;
        }
        else {
            trail_binding(goal);
            goal->term.variable.term = (put_constant(head_text));
        }
        return 1;           /* always succeeds */
    }
    else {
        /* Handle terms of different type: */
        if (goal->type != (put_constant(head_text))->type) return 0;

        switch (goal->type) {
        case Is_Constant:           /* both are constants */
            return
                strcmp(
                    goal->term.constant,
                    (put_constant(head_text))->term.constant
                ) == 0;
        case Is_Structure:          /* both are structures */
            return unify_structures(
                &goal->term.structure,
                &(put_constant(head_text))->term.structure
            );
        }
    }
}

